<?php  
if( !defined("DS") ) 
{
	define("DS", DIRECTORY_SEPARATOR);
}
require_once("core" . DS . "Bootstrap.php");
if( !defined("WHMCS") ) 
{
	exit( "This file cannot be accessed directly" );
}
class digitalocean_droplets_license_11PDOWrapper 
{
	private static $pdoConnection = NULL;
	private static function getDbConnection() 
	{
		if( class_exists("Illuminate\\Database\\Capsule\\Manager") ) 
		{
			return Illuminate\Database\Capsule\Manager::connection()->getPdo();
		}
		if( self::$pdoConnection === NULL ) 
		{
			self::$pdoConnection = self::setNewConnection();
		}
		return self::$pdoConnection;
	}
	private static function setNewConnection() 
	{
		try 
		{
			$includePath = ROOTDIR . DIRECTORY_SEPARATOR . "configuration.php";
			if( file_exists($includePath) ) 
			{
				require($includePath);
				$connection = new PDO(sprintf("mysql:host=%s;dbname=%s;port=%s;charset=utf8", $db_host, $db_name, ($db_port ? $db_port : 3360)), $db_username, $db_password);
				$connection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
				return $connection;
			}
			throw new Exception("No configuration file found");
		}
		catch( PDOException $exc ) 
		{
		}
	}
	public static function query($query, $params = array( )) 
	{
		$statement = self::getDbConnection()->prepare($query);
		$statement->execute($params);
		return $statement;
	}
	public static function real_escape_string($string) 
	{
		return substr(self::getDbConnection()->quote($string), 1, -1);
	}
	public static function fetch_assoc($query) 
	{
		return $query->fetch(PDO::FETCH_ASSOC);
	}
	public static function fetch_array($query) 
	{
		return $query->fetch(PDO::FETCH_BOTH);
	}
	public static function fetch_object($query) 
	{
		return $query->fetch(PDO::FETCH_OBJ);
	}
	public static function num_rows($query) 
	{
		$query->fetch(PDO::FETCH_BOTH);
		return $query->rowCount();
	}
	public static function insert_id() 
	{
		return self::getDbConnection()->lastInsertId();
	}
	public static function errorInfo() 
	{
		$tmpErr = self::getDbConnection()->errorInfo();
		if( $tmpErr[0] && $tmpErr[0] !== "00000" ) 
		{
			return $tmpErr;
		}
		return false;
	}
	public static function mysql_get_array($query, $params = array( )) 
	{
		$qRes = self::query($query, $params);
		$arr = array( );
		while( $row = self::fetch_assoc($qRes) ) 
		{
			$arr[] = $row;
		}
		return $arr;
	}
	public static function mysql_get_row($query, $params = array( )) 
	{
		$qRes = self::query($query, $params);
		return self::fetch_assoc($qRes);
	}
}
function DigitalOceanDroplets_MetaData() 
{
	return array( "DisplayName" => "DigitalOcean Droplets", "RequiresServer" => true );
}
function DigitalOceanDroplets_ConfigOptions($params) 
{
	if( $_GET["action"] != "save" ) 
	{
		$license_check = digitalocean_droplets_license_11();
		if( $license_check["status"] != "Active" ) 
		{
			$error_message = (isset($license_custom_error_message) ? $license_custom_error_message : "License " . $license_check["status"] . (($license_check["description"] ? ": " . $license_check["description"] : "")));
			throw new Exception($error_message);
		}
		$configOption = new ModulesGarden\Servers\DigitalOceanDroplets\App\Helpers\ConfigOptions();
		return $configOption->getConfig();
	}
}
function DigitalOceanDroplets_TestConnection(array $params) 
{
	try 
	{
		$connectionTester = new ModulesGarden\Servers\DigitalOceanDroplets\App\Helpers\TestConnection($params);
		$connectionTester->testConnection();
		return array( "success" => true );
	}
	catch( Exception $exc ) 
	{
		return array( "error" => $exc->getMessage() );
	}
}
function DigitalOceanDroplets_CreateAccount(array $params) 
{
	$license_check = digitalocean_droplets_license_11();
	if( $license_check["status"] != "Active" ) 
	{
		$error_message = (isset($license_custom_error_message) ? $license_custom_error_message : "License " . $license_check["status"] . (($license_check["description"] ? ": " . $license_check["description"] : "")));
		return $error_message;
	}
	$action = new ModulesGarden\Servers\DigitalOceanDroplets\App\Helpers\AccoutnActions($params);
	return $action->create();
}
function DigitalOceanDroplets_SuspendAccount(array $params) 
{
	$license_check = digitalocean_droplets_license_11();
	if( $license_check["status"] != "Active" ) 
	{
		$error_message = (isset($license_custom_error_message) ? $license_custom_error_message : "License " . $license_check["status"] . (($license_check["description"] ? ": " . $license_check["description"] : "")));
		return $error_message;
	}
	$action = new ModulesGarden\Servers\DigitalOceanDroplets\App\Helpers\AccoutnActions($params);
	return $action->suspendAccount();
}
function DigitalOceanDroplets_UnsuspendAccount(array $params) 
{
	$license_check = digitalocean_droplets_license_11();
	if( $license_check["status"] != "Active" ) 
	{
		$error_message = (isset($license_custom_error_message) ? $license_custom_error_message : "License " . $license_check["status"] . (($license_check["description"] ? ": " . $license_check["description"] : "")));
		return $error_message;
	}
	$action = new ModulesGarden\Servers\DigitalOceanDroplets\App\Helpers\AccoutnActions($params);
	return $action->unsuspendAccount();
}
function DigitalOceanDroplets_TerminateAccount(array $params) 
{
	$license_check = digitalocean_droplets_license_11();
	if( $license_check["status"] != "Active" ) 
	{
		$error_message = (isset($license_custom_error_message) ? $license_custom_error_message : "License " . $license_check["status"] . (($license_check["description"] ? ": " . $license_check["description"] : "")));
		return $error_message;
	}
	$action = new ModulesGarden\Servers\DigitalOceanDroplets\App\Helpers\AccoutnActions($params);
	return $action->terminateAccount();
}
function DigitalOceanDroplets_ChangePassword(array $params) 
{
	$license_check = digitalocean_droplets_license_11();
	if( $license_check["status"] != "Active" ) 
	{
		$error_message = (isset($license_custom_error_message) ? $license_custom_error_message : "License " . $license_check["status"] . (($license_check["description"] ? ": " . $license_check["description"] : "")));
		return $error_message;
	}
	$action = new ModulesGarden\Servers\DigitalOceanDroplets\App\Helpers\AccoutnActions($params);
	return $action->resetPassword();
}
function DigitalOceanDroplets_ChangePackage(array $params) 
{
	$license_check = digitalocean_droplets_license_11();
	if( $license_check["status"] != "Active" ) 
	{
		$error_message = (isset($license_custom_error_message) ? $license_custom_error_message : "License " . $license_check["status"] . (($license_check["description"] ? ": " . $license_check["description"] : "")));
		return $error_message;
	}
	$action = new ModulesGarden\Servers\DigitalOceanDroplets\App\Helpers\AccoutnActions($params);
	return $action->changePackage();
}
function DigitalOceanDroplets_ClientArea($params) 
{
	try 
	{
		$serviceManager = new ModulesGarden\Servers\DigitalOceanDroplets\App\Helpers\ServiceManager($params);
		$serviceManager->getVM();
		if( class_exists("\\ModulesGarden\\Servers\\DigitalOceanDroplets\\Core\\Http\\ClientPageControler") ) 
		{
			$pageControler = new ModulesGarden\Servers\DigitalOceanDroplets\Core\Http\ClientPageControler($params);
			$resault = $pageControler->loadPage();
		}
		return $resault;
	}
	catch( Exception $exc ) 
	{
		$exceptionToken = md5(time());
		logModuleCall("DigitalOceanDroplets - " . $exceptionToken, "DigitalOceanDroplets_ClientArea", array( "error" => $exc->getMessage(), "trace" => $exc->getTraceAsString() ), $params);
		return array( "tabOverviewReplacementTemplate" => "templates/client/errors/error.tpl", "templateVariables" => array( "errorMessage" => $exc->getMessage() ) );
	}
}
function DigitalOceanDroplets_AdminServicesTabFields($params) 
{
	try 
	{
		$serviceManager = new ModulesGarden\Servers\DigitalOceanDroplets\App\Helpers\ServiceManager($params);
		$serviceManager->getVM();
		return array( "" => ModulesGarden\Servers\DigitalOceanDroplets\Core\Helper\sl("adminProductPage")->setParams($params)->execute() );
	}
	catch( Exception $ex ) 
	{
	}
}
function digitalocean_droplets_license_11() 
{

		return array( "status" => "Active", "description" => "Your module license is active." );
 
}
?>